const fs = require('node:fs');

const formatMentions = text => {
    const matcher = /@(\w+)@([a-zA-Z\-_0-9\.]+)/gm;
    return text.replace(matcher, (match, username, domain) => {
        return `[${match}](https://${domain}/@${username})`;
    });
    
}

module.exports = function() {
    const notes = JSON.parse(fs.readFileSync('./src/_data/_notes.json', 'utf-8'))
        .filter(note => note.text !== null && note.visibility === "public")
        .map(note => ({
            ...note,
            text: formatMentions(note.text),
            createdAt: new Date(note.createdAt),
            replies: []
        }));
    
    notes.forEach(note => {
        if (note.replyId) {
            notes.find(replied => replied.id === note.replyId)?.replies.push(note);
        }
    });
    
    console.log(JSON.stringify(notes.filter(note => note.replies.length && note.replies.find(reply => reply.replies.length)), null, 2));
    return notes;
}